/*****************************************************************************
******************************************************************************
*
*               VRML CylinderSensor node
*
*               $Revision: 1.1.2.1 $
*               $Date: 2009/01/22 15:48:35 $
*               $Author: Xjhouska $
*
******************************************************************************
*****************************************************************************/

// Copyright (C) 1998  Chris Morley
// Modified by HUMUSOFT s.r.o.  Copyright 1998-2009 HUMUSOFT s.r.o.

//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#ifndef VRMLNODECYLINDERSENSOR_H
#define VRMLNODECYLINDERSENSOR_H

#include "VrmlNodeChild.h"
#include "VrmlField.h"

class VrmlScene;

class VrmlNodeCylinderSensor : public VrmlNodeChild {

public:

  // Define the fields of CylinderSensor nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType & nodeType() const;

  VrmlNodeCylinderSensor( VrmlScene *scene = 0);
  virtual ~VrmlNodeCylinderSensor();

  virtual VrmlNode *cloneMe() const;

  virtual ostream& printFields(ostream& os, int indent);

  virtual const VrmlField *getField(const char *fieldName) const;
  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

  virtual void accumulateTransform( VrmlNode* );
  virtual VrmlNode* getParentTransform();

  void activate( double timeStamp, bool isActive, double *p );

  bool isEnabled() { return d_enabled.get(); }

private:

  // Fields
  VrmlSFBool d_autoOffset;
  VrmlSFFloat d_diskAngle;
  VrmlSFBool d_enabled;
  VrmlSFFloat d_maxAngle;
  VrmlSFFloat d_minAngle;
  VrmlSFFloat d_offset;

  VrmlSFBool d_isActive;
  VrmlSFRotation d_rotation;
  VrmlSFVec3f d_trackPoint;

  VrmlSFVec3f d_activationPoint;
  VrmlNode *d_parentTransform;
  Matrix4x4 d_activationMatrix;
  bool d_diskmode;

};

#endif
