/*****************************************************************************
******************************************************************************
*
*               VRML Texture node
*
*               $Revision: 1.1.2.2 $
*               $Date: 2010/07/01 11:41:36 $
*               $Author: Xjhouska $
*
******************************************************************************
*****************************************************************************/

// Copyright (C) 1998  Chris Morley
// Modified by HUMUSOFT s.r.o.  Copyright 1998-2009 HUMUSOFT s.r.o.

//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#ifndef VRMLNODETEXTURE_H
#define VRMLNODETEXTURE_H

#include "VrmlNode.h"
#include "VrmlField.h"


class VrmlNodeTexture : public VrmlNode {

public:

  // Constructor and destructor
  VrmlNodeTexture(VrmlScene *s) : VrmlNode(s)
    { };
  virtual ~VrmlNodeTexture()
    { };

  // Define the fields of Texture nodes
  static VrmlNodeType* defineType(VrmlNodeType *t)
    { return VrmlNode::defineType(t); }

  virtual size_t nComponents() = 0;
  virtual size_t width() = 0;
  virtual size_t height() = 0;
  virtual size_t nFrames() = 0;
  virtual const unsigned char * pixels() = 0;

  void addToScene( VrmlScene *scene, const char *relativeUrl )
    { d_scene = scene; d_relativeUrl.set( relativeUrl ); }


protected:

  VrmlSFString d_relativeUrl;

};

#endif
