/*****************************************************************************
******************************************************************************
*
*               Ancestor for other VRML entities
*
*               $Revision: 1.1.2.2 $
*               $Date: 2010/02/17 09:33:28 $
*               $Author: Xjhouska $
*
******************************************************************************
*****************************************************************************/

// Copyright 1998-2010 HUMUSOFT s.r.o.

//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//


#include "VrmlObject.h"

#include <boost/algorithm/string/split.hpp>
#include <boost/algorithm/string/classification.hpp>

#include <vector>


std::ostream& VrmlObject::printComment(std::ostream& os, int indent, bool breakLine) const
{
  std::string breakStr(indent+1, ' ');
  breakStr[0] = '\n';

  // break line if desired
  if (breakLine)
    os << breakStr;

  // print comment
  std::vector<std::string> splitted;
  boost::algorithm::split(splitted, d_comment, boost::algorithm::is_any_of("\n"));
  for (std::vector<std::string>::const_iterator it=splitted.begin(); it!=splitted.end(); ++it)
  {
    const std::string& comment(*it);
    if (!comment.empty())
    {
      os << '#';
      if (comment[0] != '_') os << ' ';   // do not prepend a space if comment starts with underline
      os << comment << breakStr;
    }
  }

  return os;
}


