/*****************************************************************************
******************************************************************************
*
*               Wrapper for VrmlNodeType -- it allows to access
*               VRML nodes in VrmlNodeType via VrmlScene pointer.
*
*               $Revision: 1.1.2.2 $
*               $Date: 2011/07/26 12:41:26 $
*               $Author: Xjhouska $
*
******************************************************************************
*****************************************************************************/

// Copyright 1998-2011 HUMUSOFT s.r.o.

#ifndef VRMLSCENEFROMNODETYPE_H
#define VRMLSCENEFROMNODETYPE_H

#include "VrmlScene.h"

class OPENVRMLDLLEXPORT VrmlSceneFromNodeType : public VrmlScene
{
public:
  VrmlSceneFromNodeType(VrmlNodeType* type, VrmlScene* parentScene);

  // destructor is virtual
  ~VrmlSceneFromNodeType();

  ///////////////////////////
  ///// virtual methods	/////
  ///////////////////////////
  bool reload(bool preserveBindings = true);
  void open();
  void close();
  VrmlNamespace* scope();
  VrmlNodeGroup* nodes();
  VrmlNode* findNode(const char* name);
  void removeNode(VrmlNode* node);
  Doc* urlDoc();
  VrmlScene* getParent();
  VrmlScene* getTopLevelParent();
  VrmlNodeType* getNodeType();
  bool isEdited();
  void setModified();
  void clearModified();
  bool isModified() const;

  // Gets current clipboard owner's top ancestor
  static VrmlScene* getClipboardOwnerTopLevelParent();

private:
  VrmlNodeType* d_nodeType;
  VrmlScene* d_parent;

};

#endif // VrmlSceneFromNodeType
